/* ***********************************************************
 * This file was automatically generated on 2021-01-15.      *
 *                                                           *
 * C# Bindings Version 2.1.29                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  2-axis joystick with push-button
	/// </summary>
	public class BrickletJoystick : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 210;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Joystick Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_POSITION = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_IS_PRESSED = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_CALIBRATE = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_POSITION_CALLBACK_PERIOD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_POSITION_CALLBACK_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_POSITION_CALLBACK_THRESHOLD = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_POSITION_CALLBACK_THRESHOLD = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 13;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 14;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_POSITION = 15;

		private const int CALLBACK_ANALOG_VALUE = 16;

		private const int CALLBACK_POSITION_REACHED = 17;

		private const int CALLBACK_ANALOG_VALUE_REACHED = 18;

		private const int CALLBACK_PRESSED = 19;

		private const int CALLBACK_RELEASED = 20;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackPeriod"/>. The parameter is the position of the
		///  joystick.
		///  
		///  The <see cref="Tinkerforge.BrickletJoystick.PositionCallback"/> callback is only triggered if the position has changed since the
		///  last triggering.
		/// </summary>
		public event PositionEventHandler PositionCallback;
		/// <summary>
		/// </summary>
		public delegate void PositionEventHandler(BrickletJoystick sender, short x, short y);

		/// <summary>
		/// </summary>
		public event PositionEventHandler Position // for backward compatibility
		{
			add { PositionCallback += value; }
			remove { PositionCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackPeriod"/>. The parameters are the
		///  analog values of the joystick.
		///  
		///  The <see cref="Tinkerforge.BrickletJoystick.AnalogValueCallback"/> callback is only triggered if the values have changed
		///  since the last triggering.
		/// </summary>
		public event AnalogValueEventHandler AnalogValueCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueEventHandler(BrickletJoystick sender, int x, int y);

		/// <summary>
		/// </summary>
		public event AnalogValueEventHandler AnalogValue // for backward compatibility
		{
			add { AnalogValueCallback += value; }
			remove { AnalogValueCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackThreshold"/> is reached.
		///  The parameters are the position of the joystick.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletJoystick.SetDebouncePeriod"/>.
		/// </summary>
		public event PositionReachedEventHandler PositionReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void PositionReachedEventHandler(BrickletJoystick sender, short x, short y);

		/// <summary>
		/// </summary>
		public event PositionReachedEventHandler PositionReached // for backward compatibility
		{
			add { PositionReachedCallback += value; }
			remove { PositionReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameters are the analog values of the joystick.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletJoystick.SetDebouncePeriod"/>.
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueReachedEventHandler(BrickletJoystick sender, int x, int y);

		/// <summary>
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReached // for backward compatibility
		{
			add { AnalogValueReachedCallback += value; }
			remove { AnalogValueReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the button is pressed.
		/// </summary>
		public event PressedEventHandler PressedCallback;
		/// <summary>
		/// </summary>
		public delegate void PressedEventHandler(BrickletJoystick sender);

		/// <summary>
		/// </summary>
		public event PressedEventHandler Pressed // for backward compatibility
		{
			add { PressedCallback += value; }
			remove { PressedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the button is released.
		/// </summary>
		public event ReleasedEventHandler ReleasedCallback;
		/// <summary>
		/// </summary>
		public delegate void ReleasedEventHandler(BrickletJoystick sender);

		/// <summary>
		/// </summary>
		public event ReleasedEventHandler Released // for backward compatibility
		{
			add { ReleasedCallback += value; }
			remove { ReleasedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletJoystick(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_POSITION] = new CallbackWrapper(OnPositionCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE] = new CallbackWrapper(OnAnalogValueCallback);
			callbackWrappers[CALLBACK_POSITION_REACHED] = new CallbackWrapper(OnPositionReachedCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE_REACHED] = new CallbackWrapper(OnAnalogValueReachedCallback);
			callbackWrappers[CALLBACK_PRESSED] = new CallbackWrapper(OnPressedCallback);
			callbackWrappers[CALLBACK_RELEASED] = new CallbackWrapper(OnReleasedCallback);


			responseExpected[FUNCTION_GET_POSITION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_IS_PRESSED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_CALIBRATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_SET_POSITION_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_POSITION_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_POSITION_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_POSITION_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the position of the joystick. The middle position of the joystick is x=0, y=0.
		///  The returned values are averaged and calibrated (see <see cref="Tinkerforge.BrickletJoystick.Calibrate"/>).
		///  
		///  If you want to get the position periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletJoystick.PositionCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackPeriod"/>.
		/// </summary>
		public void GetPosition(out short x, out short y)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_POSITION);

			byte[] response = SendRequest(request, 12);

			x = LEConverter.ShortFrom(8, response);
			y = LEConverter.ShortFrom(10, response);
		}

		/// <summary>
		///  Returns *true* if the button is pressed and *false* otherwise.
		///  
		///  It is recommended to use the <see cref="Tinkerforge.BrickletJoystick.PressedCallback"/> and <see cref="Tinkerforge.BrickletJoystick.ReleasedCallback"/> callbacks
		///  to handle the button.
		/// </summary>
		public bool IsPressed()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_IS_PRESSED);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Returns the values as read by a 12-bit analog-to-digital converter.
		///  
		///  <note>
		///   The values returned by <see cref="Tinkerforge.BrickletJoystick.GetPosition"/> are averaged over several samples
		///   to yield less noise, while <see cref="Tinkerforge.BrickletJoystick.GetAnalogValue"/> gives back raw
		///   unfiltered analog values. The only reason to use <see cref="Tinkerforge.BrickletJoystick.GetAnalogValue"/> is,
		///   if you need the full resolution of the analog-to-digital converter.
		///  </note>
		///  
		///  If you want the analog values periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletJoystick.AnalogValueCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public void GetAnalogValue(out int x, out int y)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE);

			byte[] response = SendRequest(request, 12);

			x = LEConverter.UShortFrom(8, response);
			y = LEConverter.UShortFrom(10, response);
		}

		/// <summary>
		///  Calibrates the middle position of the joystick. If your Joystick Bricklet
		///  does not return x=0 and y=0 in the middle position, call this function
		///  while the joystick is standing still in the middle position.
		///  
		///  The resulting calibration will be saved on the EEPROM of the Joystick
		///  Bricklet, thus you only have to calibrate it once.
		/// </summary>
		public void Calibrate()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_CALIBRATE);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletJoystick.PositionCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletJoystick.PositionCallback"/> callback is only triggered if the position has changed since the
		///  last triggering.
		/// </summary>
		public void SetPositionCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_POSITION_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackPeriod"/>.
		/// </summary>
		public long GetPositionCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_POSITION_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletJoystick.AnalogValueCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletJoystick.AnalogValueCallback"/> callback is only triggered if the analog values have
		///  changed since the last triggering.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public long GetAnalogValueCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletJoystick.PositionReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the position is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the position is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the position is smaller than the min values (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the position is greater than the min values (max is ignored)"
		///  </code>
		/// </summary>
		public void SetPositionCallbackThreshold(char option, short minX, short maxX, short minY, short maxY)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(17, FUNCTION_SET_POSITION_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)minX, 9, request);
			LEConverter.To((short)maxX, 11, request);
			LEConverter.To((short)minY, 13, request);
			LEConverter.To((short)maxY, 15, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackThreshold"/>.
		/// </summary>
		public void GetPositionCallbackThreshold(out char option, out short minX, out short maxX, out short minY, out short maxY)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_POSITION_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 17);

			option = LEConverter.CharFrom(8, response);
			minX = LEConverter.ShortFrom(9, response);
			maxX = LEConverter.ShortFrom(11, response);
			minY = LEConverter.ShortFrom(13, response);
			maxY = LEConverter.ShortFrom(15, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletJoystick.AnalogValueReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the analog values are *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the analog values are *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the analog values are smaller than the min values (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the analog values are greater than the min values (max is ignored)"
		///  </code>
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, int minX, int maxX, int minY, int maxY)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(17, FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)minX, 9, request);
			LEConverter.To((short)maxX, 11, request);
			LEConverter.To((short)minY, 13, request);
			LEConverter.To((short)maxY, 15, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out int minX, out int maxX, out int minY, out int maxY)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 17);

			option = LEConverter.CharFrom(8, response);
			minX = LEConverter.UShortFrom(9, response);
			maxX = LEConverter.UShortFrom(11, response);
			minY = LEConverter.UShortFrom(13, response);
			maxY = LEConverter.UShortFrom(15, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletJoystick.PositionReachedCallback"/>,
		///  * <see cref="Tinkerforge.BrickletJoystick.AnalogValueReachedCallback"/>
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackThreshold"/>,
		///  * <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletJoystick.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnPositionCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			short x = LEConverter.ShortFrom(8, response);
			short y = LEConverter.ShortFrom(10, response);
			var handler = PositionCallback;

			if (handler != null)
			{
				handler(this, x, y);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			int x = LEConverter.UShortFrom(8, response);
			int y = LEConverter.UShortFrom(10, response);
			var handler = AnalogValueCallback;

			if (handler != null)
			{
				handler(this, x, y);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnPositionReachedCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			short x = LEConverter.ShortFrom(8, response);
			short y = LEConverter.ShortFrom(10, response);
			var handler = PositionReachedCallback;

			if (handler != null)
			{
				handler(this, x, y);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueReachedCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			int x = LEConverter.UShortFrom(8, response);
			int y = LEConverter.UShortFrom(10, response);
			var handler = AnalogValueReachedCallback;

			if (handler != null)
			{
				handler(this, x, y);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnPressedCallback(byte[] response)
		{
			if (response.Length != 8)
			{
				return; // silently ignoring callback with wrong length
			}

			var handler = PressedCallback;

			if (handler != null)
			{
				handler(this);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnReleasedCallback(byte[] response)
		{
			if (response.Length != 8)
			{
				return; // silently ignoring callback with wrong length
			}

			var handler = ReleasedCallback;

			if (handler != null)
			{
				handler(this);
			}
		}
	}
}
